#!/usr/bin/perl

use strict;
use warnings;
use WWW::Mechanize;

# $Id: //depot/code/perl/vitality/vitality-2.03/vitality.pl#1 $
# usage:
#   echo or cat password | perl vitality.pl
# it will then retrieve the current activity page and store it on disk, so if
# run every five minutes it wont hammer their server

my %mon = qw(
	Jan	1
	Feb	2
	Mar	3
	Apr	4
	May	5
	Jun	6
	Jul	7
	Aug	8
	Sep	9
	Oct	10
	Nov	11
	Dec	12 );

my %data;

my ($content,$mech);

foreach my $member ( @ARGV ) {
	my $cache_file = "member_data_${member}";

	my @s;
	if( -f $cache_file ) {
		@s = stat( $cache_file );
	}

	if( -f $cache_file && time - $s[9] < 1800 ) {
		open( my $fh, "<", $cache_file ) || die "cannot open $cache_file:$!";
		while( <$fh> ) {
			$content .= $_;
		}
		close( $fh );
	}
	else {
		if( !defined( $mech ) ) {
			$mech = WWW::Mechanize->new(); 
			$mech->get( "https://member.vitality.co.uk/vitality/login" ) || exit 1;
			$mech->submit_form(
				form_name => 'LoginForm',
				fields => {
					UserName => $ENV{'VUSER'},
					Password => $ENV{'VPASS'},
				},
			);
		}	

		$mech->get( "https://member.vitality.co.uk/mvc/MyPoints/GetEventListByCategory?selectedIndexValue=&month=&member=${member}" ) || exit 1;
		open( my $fh, ">", "member_data_${member}" );
		$content = $mech->content();
		print $fh $content;
		close( $fh );
	}

	my @l = split( /\n/, $content );
	my $d = 0;
	my $name;
	my $activity_type = "";
	my $next_line_activity = 0;
	foreach my $line ( @l ) {
		if( $next_line_activity == 1 ) {
			$activity_type= $line;
			$activity_type =~ s/^\s*(.*?)\s*/$1/g;
			$next_line_activity = 0;
		}
		if( $line =~ m|<h3 class="date">(\d+) (\S+)</h3>| ) {
			$d = "$1 $2";
			next;
		}
		if( $line =~ m|<h3 class="firstname">([\S ]+)</h3>| ) {
			$name = $1;
			next;
		}
		if( $line =~ m%<span class="icon-(weekexerice|dailyeat|undhealth)"></span>% ) {
			$next_line_activity = 1;
			next;
		}
		if( $line =~ m|fields points">(\d+)</span>| ) {
			my ($day, $month) = split( /\s+/, $d );
			my $date_string =
				sprintf( "2015-%.2d-%.2d", $mon{$month}, $day );
# we need to make this more like:
# $data{$date_string}->{$name}->{activity}->{points} = 
			$data{$date_string}->{$name}->{$activity_type} = $1;
			next;
		}
	}
}

foreach my $k ( sort keys %data ) {
	foreach my $n ( sort keys %{ $data{$k} } ) {
		foreach my $a ( sort keys %{ $data{$k}->{$n} } ) {
		
			if( defined( $data{$k}->{$n}->{$a} ) ) {
				printf "%s\t%s\t%s", $k, $n, $data{$k}->{$n}->{$a};
				if( defined( $data{$k}->{$n}->{$a} ) ) {
					printf( "\t%s", $a );
				}
			}
			printf( "\n" );
		}
	}
}
